#include "../../internal-include/GPU/gpu_internal.hpp"

namespace JabyEngine {
    namespace GPU {
        uint8_t Display :: current_id = 1; //< Setup will call exchange and set it to 0

        namespace internal {
            void Display :: exchange_buffer_and_display() {
                GPU::internal::set_draw_area(0, (PublicDisplay::Height*PublicDisplay::current_id));
                PublicDisplay::current_id ^= 1;
                GPU_IO::GP1 = GPU_IO::Command::DisplayArea(0, (PublicDisplay::Height*PublicDisplay::current_id));
            }
        }

        #ifndef USE_NO$PSX
            void Display :: set_offset(uint16_t x, uint16_t y) {
                x += 78;
                y += 43;

                GPU_IO::GP1 = GPU_IO::Command::HorizontalDisplayRange((x << 3), (x + Display::Width) << 3);
                GPU_IO::GP1 = GPU_IO::Command::VerticalDisplayRange(y,         y + Display::Height);
            }
        #else
            void Screen :: set_offset(uint16_t x, uint16_t y) {
                GPU_IO::GP1 = GPU_IO::Command::HorizontalDisplayRange(x, (x + Display::Width*8));
                GPU_IO::GP1 = GPU_IO::Command::VerticalDisplayRange(y - (ScanlinesV/2), y + (ScanlinesV/2));
            }
        #endif //USE_NO$PSX
    }
}